package com.wiken.gps;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;

import android.location.Address;
import android.location.Criteria;
import android.location.Geocoder;
import android.location.GpsSatellite;
import android.location.GpsStatus;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.provider.Settings;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.PendingIntent;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Color;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.TextView;


/*---------------------------------------------------------------------------------*/
// * @author Wiken
/*---------------------------------------------------------------------------------*/
public class GPSActivity extends Activity implements LocationListener,
													 OnClickListener,
													 GpsStatus.Listener
													 
{

	private static Intent		ProxIntRec	= null;
	private static final int	unique_id	= 123456;
	public static boolean 		D = false;
	public static String 		TAG = "GPSActivity";
	public static boolean 		LARGE = false;
	public boolean 				gpsB = true;
	
	public static boolean		UseNetWork = false;
	public static String 		ADR = "";

    final String[] bearings = { "  N", "NNE", " NE", "ENE", "  E", "ESE",
					            " SE", "SSE", "  S", "SSW", " SW", "WSW", 
					            "  W", "WNW", " NW", "NNW", "  N" };
	
	
	Button 				connBtn, dconBtn, scanBtn, storBtn;
	CheckBox			sec_cb;
	TextView 			ver1txt, ver2txt, ver3txt, ver4txt, ver8txt;
	TextView 			ver11txt, ver12txt, ver13txt, ver14txt;
	TextView 			ver21txt, ver22txt, ver23txt, ver24txt, ver25txt, ver26txt, ver27txt, ver28txt, ver29txt;
	TextView 			ver31txt, ver32txt, ver33txt, ver34txt, ver35txt;
//	TextView 			ver41txt, ver42txt, ver43txt, ver44txt, ver45txt;
	TextView 			ver51txt, ver52txt, ver53txt, ver54txt, ver55txt, ver56txt;
	Intent				mIntent;
	String 				mBTaddress;
	String 				mCDname;	//Name of connected device
	LocationManager 	locMgr;
	GpsStatus 			gpsStat;
	Geocoder			geoCdr;
	PendingIntent		ProxIntent;
	Calendar 			cal;
	ProximityIntentReceiver proxRec = null;
	
	double  gpsLon, gpsLat, gpsAlt, gpsAcc, gpsTme, gpsPos, gpsSpd, gpsLastLat, gpsLastLong;
	long    gpsTmr;		//Timer for GPS updates
	float   gpsDis;		//Distance for Listener to react
	float   distance;	//Distance between last position and current position.
	float   bearing;	//Bearing in degrees calculated from device travel.
	float   bearingL;	//Bearing in degrees calculated from device travel last location.
	float   gpsRad;		//Radius of the proximity.
	int 	num_sats = 0;
	int 	num_sat = 0;
	int		adr_cnt = 0;
	String	bearStr = "";
	
	public ArrayList<Double> latitudes;
	public ArrayList<Double> longitudes;
	public ArrayList<Float> distances;
	//public ArrayList<Float> bearings;
	
//	private static final int RESULT_SETTINGS = 1;

	long in_time;
	long ut_time;
	
	/******************************************************************/
	// * @see android.app.Activity#onCreate(android.os.Bundle)
	/******************************************************************/
	@Override
	protected void onCreate(Bundle savedInstanceState)
		{
		super.onCreate(savedInstanceState);
		
//		proxRec = new ProximityIntentReceiver();

		setContentView(R.layout.activity_gps);
		
		connBtn  = (Button)   findViewById(R.id.button1);
		dconBtn  = (Button)   findViewById(R.id.button2);
		scanBtn  = (Button)   findViewById(R.id.button3);
		storBtn  = (Button)   findViewById(R.id.button4);
		ver1txt  = (TextView) findViewById(R.id.textView1);
		ver2txt  = (TextView) findViewById(R.id.textView2);
		ver3txt  = (TextView) findViewById(R.id.textView3);
		ver4txt  = (TextView) findViewById(R.id.textView4);
		ver11txt = (TextView) findViewById(R.id.TextView11);
		ver12txt = (TextView) findViewById(R.id.TextView12);
		ver13txt = (TextView) findViewById(R.id.TextView13);
		ver14txt = (TextView) findViewById(R.id.TextView14);
		ver21txt = (TextView) findViewById(R.id.TextView21);
		ver22txt = (TextView) findViewById(R.id.TextView22);
		ver23txt = (TextView) findViewById(R.id.TextView23);
		ver24txt = (TextView) findViewById(R.id.TextView24);
		ver25txt = (TextView) findViewById(R.id.TextView25);
		ver26txt = (TextView) findViewById(R.id.TextView26);
		ver27txt = (TextView) findViewById(R.id.TextView27);
		ver28txt = (TextView) findViewById(R.id.TextView28);
		ver29txt = (TextView) findViewById(R.id.TextView29);
		ver31txt = (TextView) findViewById(R.id.textView31);
		ver32txt = (TextView) findViewById(R.id.textView32);
		ver33txt = (TextView) findViewById(R.id.textView33);
		ver34txt = (TextView) findViewById(R.id.textView34);
		ver35txt = (TextView) findViewById(R.id.textView35);
		/*
		ver41txt = (TextView) findViewById(R.id.TextView41);
		ver42txt = (TextView) findViewById(R.id.TextView42);
		ver43txt = (TextView) findViewById(R.id.TextView43);
		ver44txt = (TextView) findViewById(R.id.TextView44);
		ver45txt = (TextView) findViewById(R.id.TextView45);
		*/
		ver51txt = (TextView) findViewById(R.id.TextView51);
		ver52txt = (TextView) findViewById(R.id.TextView52);
		ver53txt = (TextView) findViewById(R.id.TextView53);
		ver54txt = (TextView) findViewById(R.id.TextView54);
		ver55txt = (TextView) findViewById(R.id.TextView55);
		ver56txt = (TextView) findViewById(R.id.TextView56);
		ver8txt  = (TextView) findViewById(R.id.TextView08);
		connBtn.setOnClickListener(this);
		dconBtn.setOnClickListener(this);
		scanBtn.setOnClickListener(this);
		storBtn.setOnClickListener(this);
		sec_cb = (CheckBox) findViewById(R.id.checkBox1);
		UseNetWork = sec_cb.isChecked();
		ver1txt.setText("GPS");		
		ver2txt.setText("--");
		ver3txt.setText("--");
		ver4txt.setText("--");
		ver11txt.setText("--");		
		ver12txt.setText("--");
		ver13txt.setText("--");
		ver14txt.setText("--");
		ver21txt.setText("--");		
		ver22txt.setText("--");
		ver23txt.setText("Max Satellites");
		ver24txt.setText("--");
		ver25txt.setText("Address");
		ver26txt.setText("--");
		ver27txt.setText("--");
		ver28txt.setText("GPS Time");
		ver29txt.setText("--");
		ver31txt.setText("Distance");		
		ver32txt.setText("--");
		ver33txt.setText("--");
		ver34txt.setText("--");
		ver35txt.setText("--");
		/*
		ver41txt.setText("Status");		
		ver42txt.setText("--");
		ver43txt.setText("--");
		ver44txt.setText("--");
		ver45txt.setText("--");
		*/
		ver51txt.setText("GPS Status");
		ver52txt.setText("--");
		ver53txt.setText("--");
		ver54txt.setText("--");
		ver55txt.setText("Proximity");
		ver56txt.setText("--");
		ver8txt.setText("Start...");
		
		gpsDis = 300;	  // in meters
		gpsTmr = 60000;// in milliseconds
		gpsRad = 300;  // in meters
		
	    if(gpsB)
	    	{
	    	locMgr = (LocationManager) getSystemService(LOCATION_SERVICE);
	    	locMgr.addGpsStatusListener(this);
	    	enableLocationListener();
	    	}
	    
	    cal = Calendar.getInstance();

		}
	
	/******************************************************************/
	// * @see android.app.Activity#onResume()
	/******************************************************************/
	@Override
	protected void onResume()
		{
		enableLocationListener();
		/*
		View v = getCurrentFocus();
		v.getId();
		v.invalidate();
		*/
		super.onResume();
		}

	/******************************************************************/
	// * @see android.app.Activity#onDestroy()
	/******************************************************************/
	@Override
	protected void onDestroy()
		{
		locMgr.removeUpdates(this);
		//locMgr.removeGpsStatusListener(gsl);
		//locMgr.removeNmeaListener(nsl);
		super.onDestroy();
		}

	/******************************************************************/
	// * @see android.app.Activity#onPause()
	/******************************************************************/
	@Override
	protected void onPause()
		{
		locMgr.removeUpdates(this);
		//locMgr.removeGpsStatusListener(gsl);
		super.onPause();
		}

	/******************************************************************/
	// * @see android.app.Activity#onStart()
	/******************************************************************/
	@Override
	protected void onStart()
		{
		//locMgr.removeUpdates(this);
		//locMgr.removeGpsStatusListener(gsl);
		super.onStart();
		}

	/******************************************************************/
	// * @see android.app.Activity#onStop()
	/******************************************************************/
	@Override
	protected void onStop()
		{
		locMgr.removeGpsStatusListener(this);
		locMgr.removeUpdates(this);
		super.onStop();
		}

	/******************************************************************/
	// * @see android.app.Activity#onCreateOptionsMenu(android.view.Menu)
	/******************************************************************/
	@Override
	public boolean onCreateOptionsMenu(Menu menu)
		{
		// Inflate the menu; this adds items to the action bar if it is present.
		getMenuInflater().inflate(R.menu.g, menu);
		return true;
		}

	/******************************************************************/
	// * @see android.app.Activity#onOptionsItemSelected(android.view.MenuItem)
	/******************************************************************/
	@Override
	public boolean onOptionsItemSelected(MenuItem item) 
		{
	    // Handle item selection
	    switch (item.getItemId()) 
	    	{
	        case R.id.menu_settings:
		     	// Set an EditText view to get user input 
				final EditText input = new EditText(GPSActivity.this);

				new AlertDialog.Builder(GPSActivity.this)
					.setTitle("Enter Address")
					.setMessage("Where you are now.")
					.setView(input)
					.setPositiveButton("Ok",
					new DialogInterface.OnClickListener()
						{
						public void onClick(DialogInterface dialog, int whichButton)
							{
							ADR = input.getText().toString();
							//Set first character to upper case.
							ADR = ADR.substring(0, 1).toUpperCase() + ADR.substring(1);
							}
						})
					.setNegativeButton("Cancel",
					new DialogInterface.OnClickListener()
						{
						public void onClick(DialogInterface dialog, int whichButton)
							{
							// Do nothing.
							}
						}).show();
	        	break;
	        case R.id.menu_exit:
	        	locMgr.removeUpdates(this);
	        	locMgr.removeGpsStatusListener(this);
	        	removeProximityAlert();
	        	finish();
	        	break;
	        default:
	            return super.onOptionsItemSelected(item);
	    	}
		return false;
		}
	
	/******************************************************************/
	// * @see android.location.LocationListener#onLocationChanged(android.location.Location)
	/******************************************************************/
	@Override
	public void onLocationChanged(Location arg0)
		{
		if(D)
			Log.i(TAG, "+++ GPS position Update");
		int tmp = arg0.getExtras().getInt("satellites");
		if(0 != tmp)
			ver8txt.setText("GPS position Update: " + tmp);
		else
			ver8txt.setText("GPS position Update");
		
		gpsLastLat = gpsLat;
		gpsLastLong = gpsLon;
		gpsLon = arg0.getLongitude();
		gpsLat = arg0.getLatitude();
		gpsAlt = arg0.getAltitude();
		gpsAcc = arg0.getAccuracy(); //  radius in meters with 68% probability
		gpsTme = arg0.getTime();
		gpsSpd = arg0.getSpeed(); //   meters/seconds
/*
		Date UTC_Time = new Date((long) (gpsTme * 1000));
		String UTC = UTC_Time.toString();
*/		
		
		if(Geocoder.isPresent())
			{
			if(D)
				Log.i(TAG, "+++ GeoCoder");
			getAddressFromLocation(arg0, this, new GeocoderHandler());
			}
		
		Location locationThis = new Location("This point");

		locationThis.setLatitude(gpsLat);
		locationThis.setLongitude(gpsLon);

		Location locationLast = new Location("Last point");

		locationLast.setLatitude(gpsLastLat);
		locationLast.setLongitude(gpsLastLong);

		distance = locationThis.distanceTo(locationLast);
		bearing = locationLast.bearingTo(locationThis);
		
		float[] results = new float[5];
		Location.distanceBetween(gpsLat, gpsLon, gpsLastLat, gpsLastLong, results);
		
		GpsStatus res = locMgr.getGpsStatus(gpsStat);//.getMaxSatellites();
		num_sats = res.getMaxSatellites();

		bearStr = String.format(Locale.US, bearings[Math.round((locationThis.getBearing()) / 22.5f)]);
		
        if(15.0f < gpsAcc)
        	ver11txt.setTextColor(Color.YELLOW);
        
        if(15.0f > gpsAcc)
        	ver11txt.setTextColor(Color.GREEN);
		
		
		ver1txt.setText("GPS");
		ver2txt.setText("Long: " + gpsLon);
		ver3txt.setText("Lati: " + gpsLat);
		ver4txt.setText("Alti: " + gpsAlt);
		
		ver11txt.setText("Accu: " + gpsAcc);
		ver12txt.setText("Time: " + gpsTme);
		ver13txt.setText("Sped: " + gpsSpd);
		ver14txt.setText("Bear: " + bearStr);// bearing);
		
		ver21txt.setText("Long: " + gpsLastLong);
		ver22txt.setText("Lati: " + gpsLastLat);
		ver23txt.setText("Max Satellites: ");
		ver24txt.setText("Num: " + num_sats);
		
		ver28txt.setText("GPS Time: ");
		ver29txt.setText("UTC: " );
		
		ver31txt.setText("Distance: ");
		ver32txt.setText("Bearx: " + results[0]);
		ver33txt.setText("Beary: " + results[1]);
		ver34txt.setText("Bearz: " + results[2]);
		ver35txt.setText("Bearo: " + results[3]);
		
		if(null != proxRec)
			{
			if (false == proxRec.getProxBorder())
				{
				//Exiting from ProximityArea.
				ver55txt.setTextColor(Color.RED);
				ver56txt.setTextColor(Color.RED);
				ver55txt.setText("Proximity:");
				ver56txt.setText("Exititng Area !!");
				}
			else
				{
				//Entering from ProximityArea.
				ver55txt.setTextColor(Color.WHITE);
				ver56txt.setTextColor(Color.WHITE);
				ver55txt.setText("Proximity:");
				ver56txt.setText("Into Area !!");
				}
			}
		}

	/******************************************************************/
	// * @see android.location.LocationListener#onProviderDisabled(java.lang.String)
	/******************************************************************/
	@Override
	public void onProviderDisabled(String arg0)
		{
		ver8txt.setText("Provider Off: " + arg0);
		locMgr.removeUpdates(this);
		locMgr.removeGpsStatusListener(this);
		}

	/******************************************************************/
	// * @see android.location.LocationListener#onProviderEnabled(java.lang.String)
	/******************************************************************/
	@Override
	public void onProviderEnabled(String arg0)
		{
		ver8txt.setText("Provider: " + arg0);
		enableLocationListener();
		}

	/******************************************************************/
	// * @see android.location.LocationListener#onStatusChanged(java.lang.String, int, android.os.Bundle)
	/******************************************************************/
	@Override
	public void onStatusChanged(String arg0, int arg1, Bundle arg2)
		{
		int res = 0;
		String tmp = "";
		ver8txt.setText("Status Changed"); 
		
		switch(arg1)
			{
			case 0://OUT_OF_SERVICE
				tmp = "Out Of Service";
				break;
			case 1://TEMPORARILY_UNAVAILABE
				tmp = "Temporarily Unavailable";
				break;
			case 2://AVAILABLE
				tmp = "Available";
				break;
			}
		res = arg2.getInt("satellites");
/*		
		ver41txt.setText("Status: ");
		ver42txt.setText("Provider: " + arg0);
		ver43txt.setText("Status: " + tmp);
		ver44txt.setText("Max Satellites: " + res);
*/		
		}

	/******************************************************************/
	// * @see android.view.View.OnClickListener#onClick(android.view.View)
	/******************************************************************/
	@Override
	public void onClick(View v)
		{
		switch(v.getId())
			{
			case (R.id.button1):
				if(D)
					Log.i(TAG, "+++ onClick GPS On");
				UseNetWork = sec_cb.isChecked();
				enableLocationListener();
				
				break;
			case (R.id.button2):
				if(D)
					Log.i(TAG, "+++ onClick GPS Off");
				
				removeProximityAlert();
				locMgr.removeUpdates(this);
				locMgr.removeGpsStatusListener(this);
				ver8txt.setText("GPS disabled.");
				//finish();
				
				break;
			case (R.id.button3):
				if(D)
					Log.i(TAG, "+++ onClick GPS Scan");
				locMgr.requestLocationUpdates(LocationManager.GPS_PROVIDER, gpsTmr, gpsDis, this);
				UseNetWork = sec_cb.isChecked();
				if(UseNetWork)
					locMgr.requestLocationUpdates(LocationManager.NETWORK_PROVIDER, gpsTmr, gpsDis, this);
				locMgr.addGpsStatusListener(this);
				break;
			case (R.id.button4):
				if(D)
					Log.i(TAG, "+++ onClick Store Pos.");

				//ProxIntent = PendingIntent.getActivity(this, 0, new Intent(ProxIntRec), 0);
	        	
				//Intent intent = new Intent(ProxIntRec);
	        	//ProxIntent = PendingIntent.getBroadcast(this, 0, intent, 0);

				ProxIntRec = new Intent("com.wiken.proximityintentreceiver");
				PendingIntent ProxIntent = PendingIntent.getBroadcast(getApplicationContext(), -1, ProxIntRec, 0);	        	
			
				locMgr.addProximityAlert(gpsLat, gpsLon, gpsRad, -1, ProxIntent);
				
				ver55txt.setTextColor(Color.WHITE);
				ver56txt.setTextColor(Color.WHITE);
				ver55txt.setText("Proximity:");
				ver56txt.setText("In Area !!");
				
				// KEY_PROXIMITY_ENTERING
				//public static final String KEY_PROXIMITY_ENTERING
				//Added in API level 1
				//Key used for the Bundle extra holding a boolean indicating whether a proximity 
				//alert is entering (true) or exiting (false)..
				//Constant Value: "entering"
				break;
			}
		}

	/******************************************************************/
	// * @see android.location.GpsStatus.Listener#onGpsStatusChanged(int)
	/******************************************************************/
	@Override
	public void onGpsStatusChanged(int event)
		{
		if(D)
			Log.i(TAG, "+++ onGpsStatusChanged");
		ver8txt.setText("GPS Status Changed");
		
		switch (event)
			{
			case GpsStatus.GPS_EVENT_SATELLITE_STATUS: 
				if(D)
					Log.i(TAG, "+++ Satellite Status");
				ver8txt.setText("Satellite Status");
	            gpsStat = locMgr.getGpsStatus(null);
	            int time = gpsStat.getTimeToFirstFix();
	            Iterable<GpsSatellite> sats = gpsStat.getSatellites();
	            // Check number of satellites in list to determine fix state
	            Iterator<GpsSatellite>sat = sats.iterator();
	            num_sats = gpsStat.getMaxSatellites();
	            
	            //locMgr.addProximityAlert(latitude, longitude, radius, expiration, intent);
	            while(sat.hasNext())
	            	{
	            	GpsSatellite satellite = sat.next();
	            	if(satellite.usedInFix())
	            		num_sat++;
	            	}
	            if(3 > num_sat)
	            	ver52txt.setTextColor(Color.YELLOW);
	            if(2 < num_sat)
	            	ver52txt.setTextColor(Color.GREEN);
	            	
	    		ver51txt.setText("GPS Status: ");
	            ver52txt.setText("Satellites: " + num_sat);
	    		ver53txt.setText("Sat1: " + sats.iterator().toString());
	            ver54txt.setText("Fix Time: " + time);
	            num_sat = 0;
	            
	            break;
			case GpsStatus.GPS_EVENT_STARTED:
				if(D)
					Log.i(TAG, "+++ GPS Event Started");
				ver8txt.setText("GPS Event Started");
			
				break;
			case GpsStatus.GPS_EVENT_STOPPED:
				if(D)
					Log.i(TAG, "+++ GPS Event Stoped");
				ver8txt.setText("GPS Event Stoped");
				
				break;
			case GpsStatus.GPS_EVENT_FIRST_FIX:
				if(D)
					Log.i(TAG, "+++ GPS Event First Fix");
				ver8txt.setText("GPS First Fix");
				
				break;
				
        	}        
		}

	/******************************************************************/
	// * 
	/******************************************************************/
	private void enableLocationListener()
		{
		if(gpsB)
			{
		    if(null == locMgr)
		    	locMgr = (LocationManager) getSystemService(LOCATION_SERVICE);
		    
			if(locMgr.isProviderEnabled(LocationManager.GPS_PROVIDER))
				{
				locMgr = (LocationManager) getSystemService(LOCATION_SERVICE);
				Criteria crit = new Criteria();
		        crit.setAccuracy(Criteria.ACCURACY_FINE);
		        String best = locMgr.getBestProvider(crit, false);
		        locMgr.requestLocationUpdates(best, gpsTmr, gpsDis, this);

			    boolean res = locMgr.addGpsStatusListener(this);

				if(D)
					Log.i(TAG, "+++ enableLocationListener " + res + " " + locMgr);
		        
		        if(UseNetWork)
		        	locMgr.requestLocationUpdates(LocationManager.NETWORK_PROVIDER, gpsTmr, gpsDis, this);
		        
				//locMgr.requestLocationUpdates(LocationManager.GPS_PROVIDER, gpsTmr, gpsDis, this);
				}
			else
				{
				// Check if enabled and if not send user to the GPS settings
				Intent intent = new Intent(Settings.ACTION_LOCATION_SOURCE_SETTINGS);
				startActivity(intent);
				}
			}
		}

	/******************************************************************/
	// * 
	/******************************************************************/
	private void removeProximityAlert()
		{

		String context = Context.LOCATION_SERVICE;
		LocationManager locationManager = (LocationManager) getSystemService(context);

		Intent anIntent = new Intent("com.wiken.proximityintentreceiver");
		PendingIntent operation = PendingIntent.getBroadcast(getApplicationContext(), unique_id, anIntent, 0);
		locationManager.removeProximityAlert(operation);
		ver55txt.setTextColor(Color.WHITE);
		ver56txt.setTextColor(Color.WHITE);
		ver55txt.setText("Proximity");
		ver56txt.setText("--");

		}	


	/******************************************************************/
	// * @param location
	// * @param context
	// * @param handler
	/******************************************************************/
	public static void getAddressFromLocation(final Location location,
											  final Context context, 
											  final Handler handler)
		{
		Thread thread = new Thread()
			{
				/******************************************************************/
				// * @see java.lang.Thread#run()
				/******************************************************************/
				@Override
				public void run()
					{
					Geocoder geoCdr = new Geocoder(context,
							Locale.getDefault());
					String result = null;
					try
						{
						List<Address> list = geoCdr.getFromLocation(
								location.getLatitude(),
								location.getLongitude(), 1);
						if (list != null && list.size() > 0)
							{
							Address address = list.get(0);
							// sending back first address line and locality
							result = address.getAddressLine(0) + ", "
									+ address.getLocality();
							}
						} catch (IOException e)
							{
							Log.e(TAG, "Impossible to connect to Geocoder", e);
							} finally
								{
								Message msg = Message.obtain();
								msg.setTarget(handler);
								if (result != null)
									{
									msg.what = 1;
									Bundle bundle = new Bundle();
									bundle.putString("address", result);
									msg.setData(bundle);
									}
								else
									msg.what = 0;
								msg.sendToTarget();
								}
					}
			};
		thread.start();
		}
	
	
	/*---------------------------------------------------------------------------------*/
	// * @author Wiken
	/*---------------------------------------------------------------------------------*/
	private class GeocoderHandler extends Handler
	{
		/******************************************************************/
		// * @param message
		/******************************************************************/
		public void handleMessage(Message message)
			{
			String result;
			switch (message.what)
				{
				case 1:
					Bundle bundle = message.getData();
					result = bundle.getString("address");
					if(result.contains(ADR))
						{
					    in_time = 0;
					    ut_time = in_time;
					    adr_cnt = 0;
						if(D)
							Log.i(TAG, "+++ handleMessage = " + in_time + " " + ut_time);
						ver26txt.setTextColor(Color.GREEN);
						}
					else
						{
						ut_time = cal.getTimeInMillis();
						adr_cnt++;
						if(D)
							Log.i(TAG, "+++ handleMessage ! " + in_time + " " + ut_time);
						ver26txt.setTextColor(Color.MAGENTA);
						}
					
					long interval = ut_time - in_time;
					if(59000 < interval)
						ver26txt.setTextColor(Color.YELLOW);
					if(10 < adr_cnt)
						ver26txt.setTextColor(Color.RED);
					if(D)
						Log.i(TAG, "+++ handleMessage i " + interval + " " + in_time + " " + ut_time);

					if(gpsAcc > gpsRad/20)
						{
						if(0.2 > gpsSpd)
							{
							if(3 > num_sat)
								{
								ver26txt.setTextColor(Color.GRAY);
								}
							}
						}
					
					
					ver25txt.setText("Address: " + adr_cnt);
					ver26txt.setText(result);
					ver27txt.setText(ADR);
					break;
				default:
					result = null;
				}
			// replace by what you need to do

			}
	}	
	
	
}
