/*---------------------------------------------------------------------------------*/
package com.wiken.gps;

import android.app.PendingIntent;
import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.location.LocationManager;
import android.widget.Toast;

/*---------------------------------------------------------------------------------*/
//* @author Wiken
/*---------------------------------------------------------------------------------*/
public class ProximityIntentReceiver extends BroadcastReceiver
{
	public boolean border = true;
	public static boolean ENTERING = true;
	public static boolean EXITING = false;
	
	/******************************************************************/
	// * @see android.content.BroadcastReceiver#onReceive(android.content.Context, android.content.Intent)
	/******************************************************************/
	@Override
	public void onReceive(Context arg0, Intent arg1) 
		{
		 // The receiver gets the Context & the Intent that fired the broadcast as arg0 & agr1 
		 
		 String k = LocationManager.KEY_PROXIMITY_ENTERING;
		 // Key for determining whether user is leaving or entering 
		 // We set the default value to the mode we not want to monitor.
		 // If we want to know if we exit the area, WE SET IT TO ENTERING AS DEFAULT.
		 boolean state = arg1.getBooleanExtra(k, ENTERING);
		 //Gives whether the user is entering or leaving in boolean form
		 
		 if(state)
			 {
			 // Call the Notification Service or anything else that you would like to do here
			 border = ENTERING;
			 //Toast.makeText(arg0, "Welcome to my Area", Toast.LENGTH_LONG).show();
			 }
		 else
			 {
			 //Other custom Notification 
			 border = EXITING;
			 //Toast.makeText(arg0, "Thank you for visiting my Area,come back again !!", Toast.LENGTH_LONG).show();
			 }
		}
	
	/******************************************************************/
	// * @return
	/******************************************************************/
	public boolean getProxBorder()
		{
		return border;
		}

 }
